/*
  Copyright (C) 2013 Alessandro Bugatti (alessandro.bugatti@istruzione.it)

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

/*! \file
 *  \brief 
 *  \author Alessandro Bugatti
 *  \version 0.1
 *  \date  Creazione 12-gen-2018
 *  \date  Ultima modifica 12-gen-2018
 */

package sequenzavettorestatico;


public class Sequenza {
    static final private int LUNGHEZZA = 100000;
    private final Nodo nodi[];
    private int quanti;
    public Sequenza()
    {
        nodi = new Nodo[LUNGHEZZA];
        quanti = 0;
    }
    
    @Override
    public String toString()
    {
        if (quanti == 0)
            return " -|";
        String s = "";
        for (int i = 0; i < quanti - 1; i++)
            s += nodi[i].getInfo() + " -> ";
        s += nodi[quanti-1].getInfo() + " -|";
        return s;        
    }
    
    public void inserisciInCoda(int n)
    {
        if (quanti == LUNGHEZZA)
            return;
        nodi[quanti] = new Nodo(n);
        quanti++;
    }
    
    public void inserisciInTesta(int n)
    {
        if (quanti == LUNGHEZZA)
            return;
        for (int i = quanti; i >0 ; i--)
            nodi[i] = nodi[i-1];
        nodi[0] = new Nodo(n);
        quanti++;        
    }
    
    public void inserisciInPosizione(int pos, int n)
    {
        if (quanti == LUNGHEZZA)
            return;
        if (pos < 0)
            inserisciInTesta(n);
        else if (pos > quanti)
            inserisciInCoda(n);
        else{
            for (int i = quanti; i >pos ; i--)
                nodi[i] = nodi[i-1];
            nodi[pos] = new Nodo(n);
            quanti++;        
        }
    }
}
